#pragma once

#include "afxwin.h"
using namespace std;

class CGraph
{
public:
	CGraph(void);
	double	*igdata;
	double	*qgdata;
	int		writecount,gamenlength;

	int	coloroffset;
	void DrawFFT(CPaintDC &dc,int point,double samplerate,int startpos,int endpos,int mousepos,double maxlevel);
	void DrawIQ(CPaintDC &dc,double xbai,double ybai);
	void DrawFFTFall(CPaintDC &dc,int point,int startpos,int endpos);
	


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	void CalcPeak(double *data,int n,int *peakpos);
	COLORREF CalcColor(double level);
	void CreateWindowFunction(double data[],int nn);
	void fft(int n, double theta, double ar[], double ai[]);


	void SetData(double ida[],double qda[],int n);
	void SetColorOffset(int col);
	void SetLength(int len);
	void SetGamen(CRect g);
	void ResizeMemDC(CPaintDC &pDDC,CRect g);
	CRect GetGamen();
	CRect	gamen;
	CDC memDC;
	CBitmap	memBmp;
	CBitmap* pOldBmp;
	int	FallCounter;

public:
	~CGraph(void);
};
