
// TRX305Dlg.cpp : t@C
//

#include "stdafx.h"

#include "TRX305.h"
#include "TRX305Dlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//#define PRONT

#define GRAPH_FFT	0
#define GRAPH_FALL	1
#define GRAPH_CONST	2

// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CTRX305Dlg _CAO



CTRX305Dlg::CTRX305Dlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CTRX305Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

}

void CTRX305Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDITCOM, m_EditCom);
	DDX_Control(pDX, IDC_EDITPOINT, m_EditPoint);
	DDX_Control(pDX, IDC_SLIDERCOLOR, m_SldrColor);
}

BEGIN_MESSAGE_MAP(CTRX305Dlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTONOPEN, &CTRX305Dlg::OnBnClickedButtonopen)
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_HSCROLL()
END_MESSAGE_MAP()


// CTRX305Dlg bZ[W nh[

BOOL CTRX305Dlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ
	ConstZoom=1.0;
	RunState=false;
	StartPos=0;
	EndPos=POINTLENGTH-1;

	graph[GRAPH_FFT].SetLength(POINTLENGTH);
	graph[GRAPH_CONST].SetLength(POINTLENGTH);
	graph[GRAPH_FALL].SetLength(POINTLENGTH);

	CRect cClient;
	GetClientRect(&cClient);
	AdjustGamen(cClient);

	m_SldrColor.SetRange(-200,200);
	m_SldrColor.SetTicFreq(10);
	m_SldrColor.SetPageSize(5);
	m_SldrColor.SetLineSize(20);

	m_EditCom.SetWindowTextA("1");

#ifdef PRONT
	AllocConsole();
	freopen( "CONOUT$", "w", stdout );
	freopen( "CONOUT$", "w", stderr );
	freopen( "CONIN$", "r", stdin );
#endif


	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CTRX305Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CTRX305Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{

		CPaintDC dc(this); // `̃foCX ReLXg
		double	samplerate;

		if(Rate==0){
			samplerate=WFMSAMPLING;
		}
		else{
			samplerate=SAMPLING;
		}

		graph[GRAPH_FFT].DrawFFT(dc,POINTLENGTH,samplerate,StartPos,EndPos,MousePos,150.0);
		graph[GRAPH_CONST].DrawIQ(dc,ConstZoom,ConstZoom);
		graph[GRAPH_FALL].DrawFFTFall(dc,POINTLENGTH,StartPos,EndPos);

		CDialogEx::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CTRX305Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTRX305Dlg::Parser(unsigned char *buff,int n)
{
	int	i;

	for(i=0;i<n;i++){
		ParserHeader=((ParserHeader<<8)|(unsigned int)buff[i])&0x00ffffff;
		switch(ParserState){
		case 0:
			ParserCounter=0;
			if(ParserHeader==0x00030d0a){	//WFM
				Rate=0;
				ParserState=1;
			}
			else if(ParserHeader==0x000a0d0a){	//
				Rate=1;
				ParserState=1;			
			}
			break;
		case 1:
			RawData[ParserCounter++]=buff[i];

			if(ParserCounter>=DATALENGTH){
				ParserState=0;
				Converter(IData,QData,RawData,DATALENGTH);
				graph[GRAPH_FFT].SetData(IData,QData,POINTLENGTH);
				graph[GRAPH_CONST].SetData(IData,QData,POINTLENGTH);
				graph[GRAPH_FALL].SetData(IData,QData,POINTLENGTH);
				InvalidateRect(graph[GRAPH_FFT].GetGamen(),FALSE);
				InvalidateRect(graph[GRAPH_CONST].GetGamen(),FALSE);
				InvalidateRect(graph[GRAPH_FALL].GetGamen(),FALSE);
			}
			break;
		}
	}
}
//     7   6   5   4   3   2   1   0
// 0:  0   I17 I16 I15 I14 I13 I12 I11 + 0x20
// 1:  0   I10 I9  I8  I7  I6  I5  I4  + 0x20
// 2:  0   I3  I2  I1  I0  Q17 Q16 Q15 + 0x20
// 3:  0   Q14 Q13 Q12 Q11 Q10 Q9  Q8  + 0x20
// 4:  0   Q7  Q6  Q5  Q4  Q3  Q2  Q1  + 0x20
// 5:  0   Q0  0   0   Ex3 Ex2 Ex1 Ex0 + 0x20
// Ix2^-n, Qx2^-n
void CTRX305Dlg::Converter(double *idata,double *qdata,unsigned char *src,int inlength)
{
	int	i,j;
	int data;		//32bit
	double	ex;

	for(i=0;i<inlength;i++){
		src[i]=src[i]-0x20;
	}
	j=0;
	for(i=0;i<inlength;i+=6){

		// 5:  0   Q0  0   0   Ex3 Ex2 Ex1 Ex0
		ex=(double)(1<<(unsigned int)(src[i+5]&0x0f));

		//       31  30  29  28  27  26  25  24  23  22  21  20  19  18  17  16  15  14  13  12  11  10  9   8   7   6   5   4   3   2   1   0
		//0: 0   I17 I16 I15 I14 I13 I12 I11
		//1:                             0   I10 I9  I8  I7  I6  I5  I4
		//2:                                                         0   I3  I2  I1  I0  Q17 Q16 Q15
		data=(int)(((unsigned int)src[i]<<25) |
				((unsigned int)src[i+1]<<18) |
				((unsigned int)(src[i+2]&0x78)<<11));
		//       31  30  29  28  27  26  25  24  23  22  21  20  19  18  17  16  15  14  13  12  11  10  9   8   7   6   5   4   3   2   1   0
		//0: 0   I17 I17 I17 I17 I17 I17 I17 I17 I17 I17 I17 I17 I17 I17 I17 I16 I15 I14 I13 I12 I11 I10 I9  I8  I7  I6  I5  I4  I3  I2  I1  I0
		data=(int)data>>14;
		idata[j]=(double)data/ex;

		//							31  30  29  28  27  26  25  24  23  22  21  20  19  18  17  16  15  14  13  12  11  10   9   8   7   6   5   4   3   2   1   0
		//2:    0   I3  I2  I1  I0  Q17 Q16 Q15
		//3:                                0   Q14 Q13 Q12 Q11 Q10 Q9  Q8
		//4:                                                            0   Q7  Q6  Q5  Q4  Q3  Q2  Q1
		//5:                                                                                        0   Q0  0   0   Ex3 Ex2 Ex1 Ex0
		data=(int)(((unsigned int)src[i+2]<<29) |
				((unsigned int)src[i+3]<<22) |
				((unsigned int)src[i+4]<<15) |
				((unsigned int)(src[i+5]&0x40)<<8));
		//       31  30  29  28  27  26  25  24  23  22  21  20  19  18  17  16  15  14  13  12  11  10  9   8   7   6   5   4   3   2   1   0
		//0: 0   Q17 Q17 Q17 Q17 Q17 Q17 Q17 Q17 Q17 Q17 Q17 Q17 Q17 Q17 Q17 Q16 Q15 Q14 Q13 Q12 Q11 Q10 Q9  Q8  Q7  Q6  Q5  Q4  Q3  Q2  Q1  Q0
		data=(int)data>>14;
		qdata[j]=(double)data/ex;

		j++;
	}

}

void CTRX305Dlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ɃbZ[W nh[ R[hǉ邩ȀĂяo܂B
	int	n;
	unsigned char	buff[10000];

	if(nIDEvent==0){
		n=comiq.Check();
		if(n!=0){
			n=n>10000?10000:n;
			comiq.Read((BYTE*)buff,n);
			Parser(buff,n);
		}
	}
	CDialogEx::OnTimer(nIDEvent);
}

void CTRX305Dlg::AdjustGamen(CRect rct)
{
	CPaintDC dc(this); // `̃foCX ReLXg
	CRect	rc;
	int		hen;
	hen=(int)((double)rct.Height()*0.25);
	rc=rct;
	rc.top=rc.top+40;
	rc.bottom=(rct.Height()/2);
	graph[GRAPH_FFT].SetGamen(rc);

	rc.left=rct.right-hen;
	rc.bottom=rc.top+hen;
	graph[GRAPH_CONST].SetGamen(rc);

	rc=rct;
	rc.top=rct.Height()/2;
	graph[GRAPH_FALL].ResizeMemDC(dc,rc);
}
void CTRX305Dlg::OnBnClickedButtonopen()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	int	n;
	CString ss;
	m_EditCom.GetWindowTextA(ss);
	n=atoi(ss.GetBuffer());

	if(RunState==true){
		return;
	}
	if(comiq.Open(n,230400)==false){
		AfxMessageBox("COMJ܂");
		return;
	}
	ParserState=ParserCounter=ParserHeader=0;
	SetTimer(0,10,NULL);
	RunState=true;
}




void CTRX305Dlg::OnSize(UINT nType, int cx, int cy)
{
	CRect cClient;
	CDialogEx::OnSize(nType, cx, cy);


	GetClientRect(&cClient);
	AdjustGamen(cClient);
	// TODO: ɃbZ[W nh[ R[hǉ܂B
}


void CTRX305Dlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ɃbZ[W nh[ R[hǉ邩ȀĂяo܂B
	int		haba;
	double	mousepos;

	if(graph[GRAPH_CONST].gamen.PtInRect(point)==TRUE){
		ConstZoom=ConstZoom*2;
		ConstZoom=ConstZoom>100.0?100.0:ConstZoom;
	}
	else{
		haba=EndPos-StartPos;
		mousepos=(double)point.x/(double)graph[GRAPH_FFT].gamen.Width();
		mousepos=mousepos*(double)haba+StartPos;

		haba=(int)((double)haba*0.5);
		if(haba<10){
			StartPos=(int)mousepos-5;
			EndPos=(int)mousepos+5;
			if(StartPos<0){
				StartPos=0;
			}
			if(EndPos>(POINTLENGTH-1)){
				EndPos=POINTLENGTH-1;
			}
			return;
		}
		StartPos=(int)mousepos-(haba/2);
		if(StartPos<0){
			StartPos=0;
		}
		EndPos=(int)mousepos+(haba/2);
		if(EndPos>POINTLENGTH-1){
			EndPos=POINTLENGTH-1;
		}
	}

	CDialogEx::OnLButtonDown(nFlags, point);
}


void CTRX305Dlg::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ɃbZ[W nh[ R[hǉ邩ȀĂяo܂B
	int		haba;
	double	mousepos;
	if(graph[GRAPH_CONST].gamen.PtInRect(point)==TRUE){
		ConstZoom=ConstZoom/2.0;
		ConstZoom=ConstZoom<0.0?0.1:ConstZoom;
		 
	}
	else{	
		haba=EndPos-StartPos;
		mousepos=(double)point.x/(double)graph[GRAPH_FFT].gamen.Width();
		mousepos=mousepos*(double)haba+StartPos;

		haba=(int)((double)haba*1.5);
		if(haba>(POINTLENGTH-1)){
			StartPos=0;
			EndPos=POINTLENGTH-1;
			return;
		}
		StartPos=(int)mousepos-(haba/2);
		if(StartPos<0){
			StartPos=0;
		}
		EndPos=(int)mousepos+(haba/2);
		if(EndPos>POINTLENGTH-1){
			EndPos=POINTLENGTH-1;
		}

	}

	CDialogEx::OnRButtonDown(nFlags, point);
}


void CTRX305Dlg::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: ɃbZ[W nh[ R[hǉ邩ȀĂяo܂B
	double df,samplerate;
	double mousepos;
	int	haba;
	CString	ss;

	haba=EndPos-StartPos;
	mousepos=(double)point.x/(double)graph[GRAPH_FFT].gamen.Width();
	mousepos=mousepos*(double)haba+StartPos;

	MousePos=point.x;

	if(Rate==0){
		samplerate=WFMSAMPLING;
	}
	else{
		samplerate=SAMPLING;
	}
	df=samplerate/(double)POINTLENGTH;

	

	ss.Format("%+10.5fkHz",(df*mousepos)-(samplerate/2.0));

	m_EditPoint.SetWindowTextA(ss);

	CDialogEx::OnMouseMove(nFlags, point);
}

void CTRX305Dlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int	pos;
	// TODO: ɃbZ[W nh[ R[hǉ邩ȀĂяo܂B
	if((CSliderCtrl*)pScrollBar == &m_SldrColor){
		pos=m_SldrColor.GetPos();
		graph[GRAPH_FALL].SetColorOffset(pos);
	}

	CDialogEx::OnHScroll(nSBCode, nPos, pScrollBar);
}
