
// TRX305Dlg.h : wb_[ t@C
//

#pragma once
#include "afxwin.h"
#include "Serial.h"
#include "Graph.h"
#include "afxcmn.h"

#define	WFMSAMPLING	253.90625
#define	SAMPLING	63.476563


#define DATALENGTH	(1024*6)
#define POINTLENGTH	1024
// CTRX305Dlg _CAO
class CTRX305Dlg : public CDialogEx
{
// RXgNV
public:
	CTRX305Dlg(CWnd* pParent = NULL);	// WRXgN^[

// _CAO f[^
	enum { IDD = IDD_TRX305_DIALOG };
	CGraph	graph[3];
	CSerial comiq;
	void Parser(unsigned char *buff,int n);
	void Converter(double *idata,double *qdata,unsigned char *src,int inlength);
	void AdjustGamen(CRect rct);


	int	ParserState,ParserCounter;
	unsigned int ParserHeader;
	int	Rate;
	unsigned char RawData[DATALENGTH];
	double	IData[POINTLENGTH],QData[POINTLENGTH];
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g

	double	ConstZoom;
	int		StartPos,EndPos,MousePos;
	bool	RunState;

// 
protected:
	HICON m_hIcon;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedButtonopen();
	CEdit m_EditCom;
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	CEdit m_EditPoint;
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	CSliderCtrl m_SldrColor;
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
};
